#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define BUFFER_SIZE 256
#define FILENAME_SIZE 128

FILE *fileNameValidation(void);

char *readLine(int size, FILE *fp);

int isPalindrome(char *word);

void printPalindromes(int stdoutFlag, FILE *fp, FILE *fr);


int main(int argc, char *argv[]){
    FILE *fp;
    FILE *fr;
    int stdoutFlag=0;
    if(BUFFER_SIZE>1024 || BUFFER_SIZE<5){
        printf("Netinkamas buferio dydis.\n");
        exit(1);
    }
    if(argc>3){
        printf("Per daug argumentu komandineje eiluteje\n");
        exit(1);
    }
    if(argc==1){
        fp=fileNameValidation();
        stdoutFlag=1;
    }
    else{
        char *dataFileName=malloc(strlen(argv[1]+1)*sizeof(char));
        if(dataFileName==NULL){
            printf("Could not allocate memory to data filename.\n");
            exit(1);
        }
        if(argc==2){
            stdoutFlag=1;
        }
        if(argc==3){
            char *resultFileName=malloc(strlen(argv[2]+1)*sizeof(char));
            if(resultFileName==NULL){
                printf("Could not allocate memory to result filename.\n");
                exit(1);
            }
            strcpy(resultFileName, argv[2]);
            printf("Rezultatai faile %s\n",resultFileName);
            fr=fopen(resultFileName, "w");
            free(resultFileName);
        }
        strcpy(dataFileName, argv[1]);
        fp= fopen(dataFileName, "r");
        if(fp==NULL){
            printf("Komandineje eiluteje netinkamas duomenu failo pavadinimas.\n");
            fp=fileNameValidation();
        }
    }
    printPalindromes(stdoutFlag, fp, fr);

    return 0;
}
FILE *fileNameValidation(void){
    char fileName[FILENAME_SIZE];
    FILE *fp;
    while(1){
        printf("Prasome ivesti duomenu failo pavadinima:\n");
        fgets(fileName, sizeof(fileName), stdin);
        strtok(fileName, "\n");
        fp=fopen(fileName, "r");
        if(fp==NULL){
            printf("Netinkamas failo pavadinimas.\n");
        }
        else {
            printf("Duomenu failo pavadinimas sekmingai ivestas.\n");
            break;
        }
    }
    return fp;
}

char *readLine(int size, FILE *fp){
    char *buffer=(char *)malloc(size*sizeof(char));
    if(buffer==NULL){
        printf("Memory could not be allocated.\n");
        return NULL;
    }
    if(fgets(buffer, size, fp)!=NULL){
        if(buffer[strlen(buffer)-1]!='\n'){
            fscanf(fp, "%*[^\n]");
            fgetc(fp);
        }
        return buffer;
    }
    else{
        return NULL;
    }
}

int isPalindrome(char *word){
    int left=0;
    int right=strlen(word)-1;
    while(right>left){
        if(tolower(word[left])!=tolower(word[right])){
            return 0;
        }
        ++left;
        --right;
    }
    return 1;
}
void printPalindromes(int stdoutFlag, FILE *fp, FILE *fr){
    char *line= readLine(BUFFER_SIZE, fp);
    char *word;
    int count=0;

    while (line!=NULL){
        word=strtok(line, " \n");
        while(word != NULL){
            if(isPalindrome(word)){
                if(stdoutFlag==1){
                    printf("%d. %s\n", count+1, word);
                    ++count;
                }
                else{
                    fprintf(fr, "%d. %s\n", count+1, word);
                    ++count;
                }
            }
            word = strtok(NULL, " \n");
        }
        line=readLine(BUFFER_SIZE, fp);
    }
    free(line);
    fclose(fp);
    if(stdoutFlag==0){
        fclose(fr);
    }
    return;
}